VectorsRenderer
Date: 2019-10-22

org.jmol.renderspecial

## Class VectorsRenderer

- java.lang.Object
- - org.jmol.render.ShapeRenderer
  - - org.jmol.renderspecial.VectorsRenderer

-     public class VectorsRenderer
      extends ShapeRenderer

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static float` | `arrowHeadOffset`
    `private int` | `diameter`
    `private boolean` | `drawCap`
    `private boolean` | `drawShaft`
    `private javajs.util.V3` | `headOffsetVector`
    `private float` | `headScale`
    `private int` | `headWidthPixels`
    `private javajs.util.P3` | `pointArrowHead`
    `private Point3fi` | `pointVectorEnd`
    `private javajs.util.P3` | `pointVectorStart`
    `private javajs.util.P3` | `pTemp3`
    `private Point3fi` | `ptTemp`
    `private javajs.util.P3` | `ptTemp2`
    `private javajs.util.P3` | `ptTemp4`
    `private javajs.util.P3` | `screenArrowHead`
    `private javajs.util.P3` | `screenVectorEnd`
    `private javajs.util.P3` | `screenVectorStart`
    `private boolean` | `showModVecs`
    `private boolean` | `standardVector`
    `private float` | `vectorScale`
    `private boolean` | `vectorsCentered`
    `private boolean` | `vectorSymmetry`
    `private int` | `vectorTrail`
    `private boolean` | `vibrationOn`
    `private Vibration` | `vibTemp`

    - ### Fields inherited from class org.jmol.render.ShapeRenderer

      `colix, exportType, g3d, isExport, mad, ms, myVisibilityFlag, shape, shapeID, tm, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `VectorsRenderer()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `render()`
    `private void` | `renderVector(Atom atom, Vibration vib)`
    `private boolean` | `transform(short mad, Atom atom, Vibration vib, JmolModulationSet mod2)`

    - ### Methods inherited from class org.jmol.render.ShapeRenderer

      `initRenderer, isVisibleForMe, renderShape, setup, setViewerG3dShapeID`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### arrowHeadOffset

          private static final float arrowHeadOffset

      See Also:
        Constant Field Values

    - #### ptTemp

          private final Point3fi ptTemp

    - #### pointVectorStart

          private final javajs.util.P3 pointVectorStart

    - #### pointVectorEnd

          private final Point3fi pointVectorEnd

    - #### pointArrowHead

          private final javajs.util.P3 pointArrowHead

    - #### screenVectorStart

          private final javajs.util.P3 screenVectorStart

    - #### screenVectorEnd

          private final javajs.util.P3 screenVectorEnd

    - #### screenArrowHead

          private final javajs.util.P3 screenArrowHead

    - #### headOffsetVector

          private final javajs.util.V3 headOffsetVector

    - #### pTemp3

          private final javajs.util.P3 pTemp3

    - #### diameter

          private int diameter

    - #### headWidthPixels

          private int headWidthPixels

    - #### vectorScale

          private float vectorScale

    - #### vectorSymmetry

          private boolean vectorSymmetry

    - #### headScale

          private float headScale

    - #### drawShaft

          private boolean drawShaft

    - #### vibTemp

          private Vibration vibTemp

    - #### vectorsCentered

          private boolean vectorsCentered

    - #### standardVector

          private boolean standardVector

    - #### vibrationOn

          private boolean vibrationOn

    - #### drawCap

          private boolean drawCap

    - #### showModVecs

          private boolean showModVecs

    - #### vectorTrail

          private int vectorTrail

    - #### ptTemp4

          private javajs.util.P3 ptTemp4

    - #### ptTemp2

          private javajs.util.P3 ptTemp2

  - ### Constructor Detail

    - #### VectorsRenderer

          public VectorsRenderer()

  - ### Method Detail

    - #### render

          protected boolean render()

      Specified by:
        `render` in class `ShapeRenderer`

    - #### transform

          private boolean transform(short mad,
                                    Atom atom,
                                    Vibration vib,
                                    JmolModulationSet mod2)

    - #### renderVector

          private void renderVector(Atom atom,
                                    Vibration vib)